/***************************************************************************
                          ann_wc.h  -  description
                             -------------------
    begin                : wto kwi 22 2003
    copyright            : (C) 2003 by Bartosz Lis
    email                : bartoszl@ics.p.lodz.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __ANN_WC_H
#define __ANN_WC_H

#include <ann_weight.h>
#include <ann_factory.h>

namespace ANN
{

  template <class Group, class Instance=typename Group::Instance_t>
  class WC;

  //template <class Group, class Instance>//
 // class WC                             //
//                                      //

  template <class Group, class Instance>
  class WC
  {
  private:
    WC();

  public:
    typedef Group               WG_t;
    typedef FB<Group,Instance>  WG_FB_t;

    WG_t    *wg;
    WG_FB_t *wgf;

    WC(WG_FB_t &wgf_, WG_t *wg_=0) : wg(wg_), wgf(&wgf_) {}
    WC(const WC &that) : wg(that.wg), wgf(that.wgf) {}

    WC &operator = (const WC &that) { wg=that.wg; wgf=that.wgf; }
  };

} // namespace ANN

#endif /* __ANN_WC_H */
